Panda3D

Public Member Functions | Static Public Member Functions | List of all members
EggJointPointer Class Referenceabstract

This is a base class for EggJointNodePointer and EggMatrixTablePointer. More...

`#include "eggJointPointer.h"`

Inheritance diagram for EggJointPointer:

## Public Member Functions
virtual bool | add_frame (const LMatrix4d &mat)
| Appends a new frame onto the end of the data, if possible; returns true if not possible, or false otherwise (e.g. More...
virtual void | apply_default_pose (EggJointPointer *source_joint, int frame)
| Applies the pose from the indicated frame of the indicated source joint as the initial pose for this joint. More...
virtual void | do_finish_reparent (EggJointPointer *new_parent)=0
virtual bool | do_rebuild (EggCharacterDb &db)
| Rebuilds the entire table all at once, based on the frames added by repeated calls to add_rebuild_frame() since the last call to begin_rebuild(). More...
virtual void | expose (EggGroup::DCSType dcs_type)
| Flags the joint with the indicated DCS flag so that it will be loaded as a separate node in the player. More...
virtual TypeHandle | force_init_type ()
virtual LMatrix4d | get_frame (int n) const =0
virtual int | get_num_frames () const =0
virtual TypeHandle | get_type () const
virtual EggJointPointer * | make_new_joint (const std::string &name)=0
virtual void | move_vertices_to (EggJointPointer *new_joint)
| Moves the vertices assigned to this joint into the other joint (which should be of the same type). More...
virtual void | optimize ()
| Resets the table before writing to disk so that redundant rows (e.g. More...
virtual void | quantize_channels (const std::string &components, double quantum)
| Rounds the named components of the transform to the nearest multiple of quantum. More...
virtual void | set_frame (int n, const LMatrix4d &mat)=0
virtual void | zero_channels (const std::string &components)
| Zeroes out the named components of the transform in the animation frames. More...
Public Member Functions inherited from EggBackPointer
virtual void | extend_to (int num_frames)
| Extends the table to the indicated number of frames. More...
virtual double | get_frame_rate () const
| Returns the stated frame rate of this particular joint, or 0.0 if it doesn't state. More...
virtual bool | has_vertices () const
| Returns true if there are any vertices referenced by the node this points to, false otherwise. More...
virtual void | set_name (const std::string &name)
| Applies the indicated name change to the egg file. More...
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer. More...
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type. More...
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly. More...
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type. More...
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from EggBackPointer
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96. More...

## Additional Inherited Members
Public Attributes inherited from TypedObject
| get_type

## Detailed Description

This is a base class for EggJointNodePointer and EggMatrixTablePointer.

It stores a back pointer to either a <Joint> entry or an xform

, and thus presents an interface that returns 1-n matrices, one for each frame. (<Joint> entries, for model files, appear the same as one-frame animations.)

Definition at line 31 of file eggJointPointer.h.

## Member Function Documentation

## ◆ add_frame()

bool EggJointPointer::add_frame | ( | const LMatrix4d & | mat | ) |
| virtual

Appends a new frame onto the end of the data, if possible; returns true if not possible, or false otherwise (e.g.

for a static joint).

Reimplemented in EggMatrixTablePointer.

Definition at line 24 of file eggJointPointer.cxx.

## ◆ apply_default_pose()

void EggJointPointer::apply_default_pose | ( | EggJointPointer * | source_joint,
|  | int | frame
| ) |  |
| virtual

Applies the pose from the indicated frame of the indicated source joint as the initial pose for this joint.

Reimplemented in EggJointNodePointer.

Definition at line 87 of file eggJointPointer.cxx.

## ◆ do_rebuild()

bool EggJointPointer::do_rebuild | ( | EggCharacterDb & | db | ) |
| virtual

Rebuilds the entire table all at once, based on the frames added by repeated calls to add_rebuild_frame() since the last call to begin_rebuild().

Until do_rebuild() is called, the animation table is not changed.

The return value is true if all frames are acceptable, or false if there is some problem.

Reimplemented in EggMatrixTablePointer, and EggJointNodePointer.

Definition at line 47 of file eggJointPointer.cxx.

## ◆ expose()

void EggJointPointer::expose | ( | EggGroup::DCSType | dcs_type | ) |
| virtual

Flags the joint with the indicated DCS flag so that it will be loaded as a separate node in the player.

Reimplemented in EggJointNodePointer.

Definition at line 64 of file eggJointPointer.cxx.

## ◆ move_vertices_to()

void EggJointPointer::move_vertices_to | ( | EggJointPointer * | new_joint | ) |
| virtual

Moves the vertices assigned to this joint into the other joint (which should be of the same type).

Reimplemented in EggJointNodePointer.

Definition at line 33 of file eggJointPointer.cxx.

## ◆ optimize()

void EggJointPointer::optimize | ( |  | ) |
| virtual

Resets the table before writing to disk so that redundant rows (e.g.

i { 1 1 1 1 1 1 1 1 }) are collapsed out.

Reimplemented in EggMatrixTablePointer.

Definition at line 56 of file eggJointPointer.cxx.

## ◆ quantize_channels()

void EggJointPointer::quantize_channels | ( | const std::string & | components,
|  | double | quantum
| ) |  |
| virtual

Rounds the named components of the transform to the nearest multiple of quantum.

Reimplemented in EggMatrixTablePointer.

Definition at line 79 of file eggJointPointer.cxx.

## ◆ zero_channels()

void EggJointPointer::zero_channels | ( | const std::string & | components | ) |
| virtual

Zeroes out the named components of the transform in the animation frames.

Reimplemented in EggMatrixTablePointer.

Definition at line 71 of file eggJointPointer.cxx.

The documentation for this class was generated from the following files:

- pandatool/src/eggcharbase/eggJointPointer.h
- pandatool/src/eggcharbase/eggJointPointer.cxx